Modify

Opened 5 years ago

Last modified 2 years ago

#11200 reopened defect

[bcm63xx] Usb2.0 not working on Huawei HG553

Reported by: anonymous Owned by: florian
Priority: normal Milestone: Barrier Breaker 14.07
Component: luci Version: Trunk
Keywords: Cc:

Description

with the usb 2.0 its detecting 2 ports and possibly conflicting with kmod-ohci

root@OpenWrt:~# dmesg | grep hub
[ 10.812000] usbcore: registered new interface driver hub
[ 11.424000] hub 1-0:1.0: USB hub found <----------- ehci usb, near lan ports
[ 11.428000] hub 1-0:1.0: 2 ports detected <----------- its detecting 2 ports

[ 735.400000] hub 2-0:1.0: USB hub found <-----------ohci usb, on top of router
[ 735.404000] hub 2-0:1.0: 1 port detected <-----------identifies the correct single port

[ 736.192000] hub 2-1:1.0: USB hub found <---------I plugged a 4 port usb hub into the ohci port, top usb
[ 736.204000] hub 2-1:1.0: 4 ports detected <------It correctly identified 4ports
[ 1891.520000] usb 2-1: not running at top speed; connect to a high speed hub
[ 2314.004000] hub 2-1:1.0: USB hub found
[ 2314.008000] hub 2-1:1.0: 4 ports detected

I have also plugged a scandisk usbdrive with a led light into the top ohci usb port. It correctly identifies the drive no problems and the led light stays on. I noticed when i plug it into the usb 2.0 usb near the lan it goes off after 1 second. If I uninstall the kmod-ohci the led light stays on, but still doesnt get identified with lsusb.

Attachments (3)

900-board_hw553-usbfix.patch (821 bytes) - added by marcogaio 3 years ago.
900-board_hw553-usbfix-cc.patch (822 bytes) - added by marcin1j 2 years ago.
900-board_hw553-usbfix.patch adapted for trunk
900-board_hw553-usbfix-cc.2.patch (822 bytes) - added by marcin1j 2 years ago.
900-board_hw553-usbfix.patch adapted for trunk

Download all attachments as: .zip

Change History (69)

comment:1 Changed 5 years ago by anonymous

Sorry if your not familiar with the hg553 it has 2 usb ports. 1 port is ohci and the other is ehci.

comment:2 follow-up: Changed 5 years ago by sanzojn@…

I have the same problem, kmod-usb-ohci work, kmod-usb2 doesn't work. Same board, HG553

comment:3 Changed 5 years ago by anonymous

Issue has been solved. USB will only work if you install the b21 spanish version from the web then upgrade to openwrt from the web interface. It will work with the stock openwrt firmware from the repo.

comment:4 Changed 5 years ago by florian

This is not a solution, please find out what is wrong with the stock openwrt firmware. Maybe there is some GPIO to toggle. I suspect the issue will be present from one reboot to the other

comment:5 Changed 5 years ago by anonymous

@Florian
you who have more experience, you can tell me the names of the files with GPIO to check?

comment:6 Changed 5 years ago by sanzojn@…

Maybe i'm wrong, but can be an issue with NVRAM?
Maybe write B21 put good settings and then openwrt works well?

comment:7 Changed 5 years ago by protomax

this is the same issue from ticket 9351, where should i post?, maybe it could be merged.

From the test that we made, if you flash from stock (b21) and then to openwrt, usb2 works fine until power down (if you reboot the router from console, usb2 still works)

comment:8 Changed 5 years ago by protomax

No, both ports are usb 2 capable

comment:9 Changed 5 years ago by florian

Ok, so that confirms my expectations. The easiest thing to do would be to post the contents of : cat /sys/kernel/debug/gpio before power off and after power off.

comment:10 Changed 5 years ago by protomax

working

root@OpenWrt:/# cat /sys/kernel/debug/gpio
GPIOs 0-39, bcm63xx-gpio:
 gpio-4   (power:blue          ) out hi
 gpio-5   (power:red           ) out lo
 gpio-12  (internetkey:red     ) out hi
 gpio-13  (internetkey:blue    ) out hi
 gpio-22  (adsl:red            ) out hi
 gpio-23  (adsl:blue           ) out hi
 gpio-25  (wifi:red            ) out hi
 gpio-34  (lan:red             ) out hi
 gpio-35  (lan:blue            ) out hi

not working (after power off)

root@OpenWrt:/# cat /sys/kernel/debug/gpio
GPIOs 0-39, bcm63xx-gpio:
 gpio-4   (power:blue          ) out hi
 gpio-5   (power:red           ) out lo
 gpio-12  (internetkey:red     ) out hi
 gpio-13  (internetkey:blue    ) out hi
 gpio-22  (adsl:red            ) out hi
 gpio-23  (adsl:blue           ) out hi
 gpio-25  (wifi:red            ) out hi
 gpio-34  (lan:red             ) out hi
 gpio-35  (lan:blue            ) out hi

yes, i noticed that the list is incomplete, i don't know if i made something wrong.

comment:11 Changed 5 years ago by florian

  • Owner set to florian
  • Status changed from new to accepted

Can you retry, and before showing the contents of /sys/kernel/debug/gpio, please type this command:

for gpio in $(seq 0 49)
do
    echo $gpio >  /sys/class/gpio/export
done

this will make all other gpios also visible because they are not exported by default. thanks !

comment:12 Changed 5 years ago by protomax

Gpio's are identical,when is working and when is not, to be sure, i made the test twice

i'm using r30939

root@OpenWrt:/# cat /sys/kernel/debug/gpio
GPIOs 0-39, bcm63xx-gpio:
 gpio-0   (sysfs               ) in  hi
 gpio-1   (sysfs               ) in  hi
 gpio-2   (sysfs               ) in  hi
 gpio-3   (sysfs               ) in  hi
 gpio-4   (power:blue          ) out hi
 gpio-5   (power:red           ) out lo
 gpio-6   (sysfs               ) in  lo
 gpio-7   (sysfs               ) in  lo
 gpio-8   (sysfs               ) in  hi
 gpio-9   (sysfs               ) in  hi
 gpio-10  (sysfs               ) in  lo
 gpio-11  (sysfs               ) in  lo
 gpio-12  (internetkey:red     ) out hi
 gpio-13  (internetkey:blue    ) out hi
 gpio-14  (sysfs               ) in  hi
 gpio-15  (sysfs               ) in  hi
 gpio-16  (sysfs               ) in  hi
 gpio-17  (sysfs               ) in  hi
 gpio-18  (sysfs               ) in  hi
 gpio-19  (sysfs               ) in  hi
 gpio-20  (sysfs               ) in  hi
 gpio-21  (sysfs               ) in  hi
 gpio-22  (adsl:red            ) out hi
 gpio-23  (adsl:blue           ) out hi
 gpio-24  (sysfs               ) in  hi
 gpio-25  (wifi:red            ) out hi
 gpio-26  (sysfs               ) in  hi
 gpio-27  (sysfs               ) in  hi
 gpio-28  (sysfs               ) in  hi
 gpio-29  (sysfs               ) in  hi
 gpio-30  (sysfs               ) in  hi
 gpio-31  (sysfs               ) in  hi
 gpio-32  (sysfs               ) in  hi
 gpio-33  (sysfs               ) in  hi
 gpio-34  (lan:red             ) out hi
 gpio-35  (lan:blue            ) out hi
 gpio-36  (sysfs               ) in  hi
 gpio-37  (sysfs               ) in  hi
 gpio-38  (sysfs               ) in  lo
 gpio-39  (sysfs               ) in  lo

comment:13 Changed 5 years ago by stevie

hi florian, I have 2 hg553 the boards are identical and router 1 ehci works with usb 2.0 on both ports and router 2 only ohci works on the top usb port where the 3g goes.

working
root@Thai:~# cat /sys/kernel/debug/gpio
GPIOs 0-39, bcm63xx-gpio:

gpio-0 (sysfs ) in hi
gpio-1 (sysfs ) in hi
gpio-2 (sysfs ) in hi
gpio-3 (sysfs ) in hi
gpio-4 (power:blue ) out hi
gpio-5 (power:red ) out lo
gpio-6 (sysfs ) in lo
gpio-7 (sysfs ) in lo
gpio-8 (sysfs ) in hi
gpio-9 (sysfs ) in hi
gpio-10 (sysfs ) in lo
gpio-11 (sysfs ) in lo
gpio-12 (internetkey:red ) out hi
gpio-13 (internetkey:blue ) out hi
gpio-14 (sysfs ) in hi
gpio-15 (sysfs ) in hi
gpio-16 (sysfs ) in hi
gpio-17 (sysfs ) in hi
gpio-18 (sysfs ) in hi
gpio-19 (sysfs ) in hi
gpio-20 (sysfs ) in hi
gpio-21 (sysfs ) in hi
gpio-22 (adsl:red ) out hi
gpio-23 (adsl:blue ) out lo
gpio-24 (sysfs ) in hi
gpio-25 (wifi:red ) out hi
gpio-26 (sysfs ) in hi
gpio-27 (sysfs ) in hi
gpio-28 (sysfs ) in hi
gpio-29 (sysfs ) in hi
gpio-30 (sysfs ) in hi
gpio-31 (sysfs ) in hi
gpio-32 (sysfs ) in hi
gpio-33 (sysfs ) in hi
gpio-34 (lan:red ) out hi
gpio-35 (lan:blue ) out hi
gpio-36 (sysfs ) in hi
gpio-37 (sysfs ) in hi
gpio-38 (sysfs ) in lo
gpio-39 (sysfs ) in lo

Router 2 ehci not working

root@OpenWrt:~# cat /sys/kernel/debug/gpio
GPIOs 0-39, bcm63xx-gpio:

gpio-0 (sysfs ) in hi
gpio-1 (sysfs ) in hi
gpio-2 (sysfs ) in hi
gpio-3 (sysfs ) in hi
gpio-4 (power:blue ) out hi
gpio-5 (power:red ) out lo
gpio-6 (sysfs ) in lo
gpio-7 (sysfs ) in lo
gpio-8 (sysfs ) in hi
gpio-9 (sysfs ) in hi
gpio-10 (sysfs ) in lo
gpio-11 (sysfs ) in lo
gpio-12 (internetkey:red ) out hi
gpio-13 (internetkey:blue ) out hi
gpio-14 (sysfs ) in hi
gpio-15 (sysfs ) in hi
gpio-16 (sysfs ) in hi
gpio-17 (sysfs ) in hi
gpio-18 (sysfs ) in hi
gpio-19 (sysfs ) in hi
gpio-20 (sysfs ) in hi
gpio-21 (sysfs ) in hi
gpio-22 (adsl:red ) out hi
gpio-23 (adsl:blue ) out hi
gpio-24 (sysfs ) in hi
gpio-25 (wifi:red ) out hi
gpio-26 (sysfs ) in hi
gpio-27 (sysfs ) in hi
gpio-28 (sysfs ) in hi
gpio-29 (sysfs ) in hi
gpio-30 (sysfs ) in hi
gpio-31 (sysfs ) in hi
gpio-32 (sysfs ) in hi
gpio-33 (sysfs ) in hi
gpio-34 (lan:red ) out hi
gpio-35 (lan:blue ) out hi
gpio-36 (sysfs ) in hi
gpio-37 (sysfs ) in hi
gpio-38 (sysfs ) in lo
gpio-39 (sysfs ) in lo

Let me know if you want some more testing between the 2 routers

comment:14 Changed 5 years ago by anonymous

root@OpenWrt:~# cat /sys/kernel/debug/gpio
GPIOs 0-39, bcm63xx-gpio:
 gpio-0   (sysfs               ) in  hi
 gpio-1   (sysfs               ) in  hi
 gpio-2   (sysfs               ) in  hi
 gpio-3   (sysfs               ) in  hi
 gpio-4   (power:blue          ) out hi
 gpio-5   (power:red           ) out lo
 gpio-6   (sysfs               ) in  lo
 gpio-7   (sysfs               ) in  lo
 gpio-8   (sysfs               ) in  hi
 gpio-9   (sysfs               ) in  hi
 gpio-10  (sysfs               ) in  lo
 gpio-11  (sysfs               ) in  lo
 gpio-12  (internetkey:red     ) out hi
 gpio-13  (internetkey:blue    ) out hi
 gpio-14  (sysfs               ) in  hi
 gpio-15  (sysfs               ) in  hi
 gpio-16  (sysfs               ) in  hi
 gpio-17  (sysfs               ) in  hi
 gpio-18  (sysfs               ) in  hi
 gpio-19  (sysfs               ) in  hi
 gpio-20  (sysfs               ) in  hi
 gpio-21  (sysfs               ) in  hi
 gpio-22  (adsl:red            ) out hi
 gpio-23  (adsl:blue           ) out hi
 gpio-24  (sysfs               ) in  hi
 gpio-25  (wifi:red            ) out hi
 gpio-26  (sysfs               ) in  hi
 gpio-27  (sysfs               ) in  hi
 gpio-28  (sysfs               ) in  hi
 gpio-29  (sysfs               ) in  hi
 gpio-30  (sysfs               ) in  hi
 gpio-31  (sysfs               ) in  hi
 gpio-32  (sysfs               ) in  hi
 gpio-33  (sysfs               ) in  hi
 gpio-34  (lan:red             ) out hi
 gpio-35  (lan:blue            ) out hi
 gpio-36  (sysfs               ) in  hi
 gpio-37  (sysfs               ) in  hi
 gpio-38  (sysfs               ) in  lo
 gpio-39  (sysfs               ) in  lo

comment:15 Changed 5 years ago by stevie

sorry i reposted for easier reading

non working router

root@Thai:~# cat /sys/kernel/debug/gpio
GPIOs 0-39, bcm63xx-gpio:
 gpio-0   (sysfs               ) in  hi
 gpio-1   (sysfs               ) in  hi
 gpio-2   (sysfs               ) in  hi
 gpio-3   (sysfs               ) in  hi
 gpio-4   (power:blue          ) out hi
 gpio-5   (power:red           ) out lo
 gpio-6   (sysfs               ) in  lo
 gpio-7   (sysfs               ) in  lo
 gpio-8   (sysfs               ) in  hi
 gpio-9   (sysfs               ) in  hi
 gpio-10  (sysfs               ) in  lo
 gpio-11  (sysfs               ) in  lo
 gpio-12  (internetkey:red     ) out hi
 gpio-13  (internetkey:blue    ) out hi
 gpio-14  (sysfs               ) in  hi
 gpio-15  (sysfs               ) in  hi
 gpio-16  (sysfs               ) in  hi
 gpio-17  (sysfs               ) in  hi
 gpio-18  (sysfs               ) in  hi
 gpio-19  (sysfs               ) in  hi
 gpio-20  (sysfs               ) in  hi
 gpio-21  (sysfs               ) in  hi
 gpio-22  (adsl:red            ) out hi
 gpio-23  (adsl:blue           ) out lo
 gpio-24  (sysfs               ) in  hi
 gpio-25  (wifi:red            ) out hi
 gpio-26  (sysfs               ) in  hi
 gpio-27  (sysfs               ) in  hi
 gpio-28  (sysfs               ) in  hi
 gpio-29  (sysfs               ) in  hi
 gpio-30  (sysfs               ) in  hi
 gpio-31  (sysfs               ) in  hi
 gpio-32  (sysfs               ) in  hi
 gpio-33  (sysfs               ) in  hi
 gpio-34  (lan:red             ) out hi
 gpio-35  (lan:blue            ) out hi
 gpio-36  (sysfs               ) in  hi
 gpio-37  (sysfs               ) in  hi
 gpio-38  (sysfs               ) in  lo
 gpio-39  (sysfs               ) in  lo

comment:16 Changed 5 years ago by stevie

oops my router named Thai has 2 working usb with ehci, the router named openwrt ehci doesnt work

comment:17 follow-up: Changed 5 years ago by anonymous

The differences between working (Thai) and not working (openwrt) is only one GPIO:

gpio-23 (adsl:blue ) out lo (Thai)

gpio-23 (adsl:blue ) out hi (openwrt)

But it could be useless...

comment:18 Changed 5 years ago by protomax

Well, i noticed that wifi:blue led sometimes works normally and sometimes not (with openwrt), as you can see, this led is not mapped, i'm not able to reproduce the problem atm, but i think that is flash or maybe revision related.

hw553 model has a problem with power:red, is always active, as stated on the wiki, but same as before, sometimes, after a specific flash i'm able to turn it off using luci, don't know why.

Don't consider this info important because i don't know the reason of this and don't know if i got different behaviors from same flash images, could be my problem.

maybe it could be a wrong GPIO mapping?

I can't make further tests because after exporting GPIO'S i can't poke them using:

echo 1 > value (write error)
or
gpioctrl (gpio device not found)

comment:19 Changed 5 years ago by protomax

i found a recent stock firmware source here:

http://www.sbrk.co.uk/d/hg553.tar.bz2
(source: http://www.sbrk.co.uk/hw553/huawei/gpl2.html)

and here is a full boot log from my device:

Linux version 2.6.8.1 (root@IBM_x3500) (gcc version 3.4.2) #16 Thu Apr 9 11:40:07 CST 2009
Parallel flash device: name AM29LV320MT, id 0x2201, size 16384KB
Total Flash size: 16384K with 128 sectors

 Board id is set HW553
HW553 prom init
CPU revision is: 0002a010
Determined physical RAM map:
 memory: 03f91920 @ 00000000 (usable)
On node 0 totalpages: 16273
  DMA zone: 16273 pages, LIFO batch:3
  Normal zone: 0 pages, LIFO batch:1
  HighMem zone: 0 pages, LIFO batch:1
Built 1 zonelists
Kernel command line: root=31:0 ro noinitrd
brcm mips: enabling icache and dcache...
Primary instruction cache 16kB, physically tagged, 2-way, linesize 16 bytes.
Primary data cache 16kB 2-way, linesize 16 bytes.
PID hash table entries: 256 (order 8: 2048 bytes)
Using 150.000 MHz high precision timer.
Dentry cache hash table entries: 16384 (order: 4, 65536 bytes)
Inode-cache hash table entries: 8192 (order: 3, 32768 bytes)
Allocating memory for DSP module core and initialization code
Allocated DSP module memory - CORE=0x81099cc0 SIZE=532640, INIT=0x0 SIZE=0
Memory: 61548k/65092k available (1736k kernel code, 3476k reserved, 271k data, 76k init, 0k highmem)
Calibrating delay loop... 299.00 BogoMIPS
Mount-cache hash table entries: 512 (order: 0, 4096 bytes)
Checking for 'wait' instruction...  unavailable.
NET: Registered protocol family 16
Can't analyze prologue code at 801c08dc
SCSI subsystem initialized
usbcore: registered new driver usbfs
usbcore: registered new driver hub
Initializing Cryptographic API
PPP generic driver version 2.4.2
NET: Registered protocol family 24
Using noop io scheduler
bcm963xx_mtd driver v1.0
PCI: Enabling device 0000:00:0a.0 (0000 -> 0002)
ehci_hcd 0000:00:0a.0: EHCI Host Controller
PCI: Setting latency timer of device 0000:00:0a.0 to 64
ehci_hcd 0000:00:0a.0: irq 18, pci mem c0000300
ehci_hcd 0000:00:0a.0: new USB bus registered, assigned bus number 1
PCI: cache line size of 32 is not supported by device 0000:00:0a.0
ehci_hcd 0000:00:0a.0: USB f.f enabled, EHCI 1.00, driver 2004-May-10
hub 1-0:1.0: USB hub found
hub 1-0:1.0: 2 ports detected
ohci_hcd: 2004 Feb 02 USB 1.1 'Open' Host Controller (OHCI) Driver (PCI)
ohci_hcd: block sizes: ed 64 td 64
PCI: Enabling device 0000:00:09.0 (0000 -> 0002)
ohci_hcd 0000:00:09.0: OHCI Host Controller
PCI: Setting latency timer of device 0000:00:09.0 to 64
ohci_hcd 0000:00:09.0: irq 13, pci mem c0002400
ohci_hcd 0000:00:09.0: new USB bus registered, assigned bus number 2
hub 2-0:1.0: USB hub found
hub 2-0:1.0: 2 ports detected
usbcore: registered new driver usblp
drivers/usb/class/usblp.c: v0.13: USB Printer Device Class driver
Initializing USB Mass Storage driver...
usbcore: registered new driver usb-storage
USB Mass Storage support registered.
drivers/usb/serial/usb-serial.c: USB Serial support registered for Generic
usbcore: registered new driver usbserial_generic
usbcore: registered new driver usbserial
drivers/usb/serial/usb-serial.c: USB Serial Driver core v2.0
brcmboard: brcm_board_init entry
SES: Button GPIO 0x8009 is enabled
SES: LED GPIO 0x8009 is enabled
bcm963xx_serial driver v2.0
u32 classifier
NET: Registered protocol family 2
IP: routing cache hash table of 512 buckets, 4Kbytes
TCP: Hash tables configured (established 4096 bind 8192)
Initializing IPsec netlink socket
NET: Registered protocol family 1
NET: Registered protocol family 17
NET: Registered protocol family 15
Ebtables v2.0 registered
NET: Registered protocol family 8
NET: Registered protocol family 20
802.1Q VLAN Support v1.8 Ben Greear <greearb@candelatech.com>
All bugs added by David S. Miller <davem@redhat.com>
VFS: Mounted root (squashfs filesystem) readonly.
Freeing unused kernel memory: 76k freed
init started:  BusyBox v1.00 (2009.04.09-03:43+0000) multi-call binary
Algorithmics/MIPS FPU Emulator v1.5


BusyBox v1.00 (2009.04.09-03:43+0000) Built-in shell (msh)
Enter 'help' for a list of built-in commands.


Loading drivers and kernel modules...

atmapi: module license 'Proprietary' taints kernel.
blaadd: blaa_detect entry
adsl: adsl_init entry
Broadcom BCMPROCFS v1.0 initialized
Broadcom BCM6358A1 Ethernet Network Device v0.3 Apr  8 2009 11:18:06
Config Ethernet Switch Through MDIO Pseudo PHY Interface
dgasp: kerSysRegisterDyingGaspHandler: eth0 registered
eth0: MAC Address: 00:24:D2:1A:5F:81
DSP Driver: DSP init stub
eth0 Link UP.
PCI: Setting latency timer of device 0000:00:01.0 to 64
PCI: Enabling device 0000:00:01.0 (0004 -> 0006)
wl: srom not detected, using main memory mapped srom info (wombo board)
wl0: wlc_attach: use mac addr from the system pool by id: 0x776c0000
wl0: MAC Address: 00:24:D2:1A:5F:82
wl0: Broadcom BCM4318 802.11 Wireless Controller 4.150.10.15.cpe2.2b
dgasp: kerSysRegisterDyingGaspHandler: wl0 registered
Endpoint: endpoint_init entry
BOS: Enter bosInit
Enter bosAppInit
Exit bosAppInit
BOS: Exit bosInit
Endpoint: endpoint_init COMPLETED
drivers/usb/serial/usb-serial.c: USB Serial support registered for option1
usbcore: registered new driver option
drivers/usb/serial/option.c: USB Driver for GSM modems: v0.7.1
144
wlctl: Unsupported
ip is  192.168.0.1mask is  255.255.255.0, ipbegin is  192.168.0.192, ipend is  192.168.0.254
xmlGetDhcpHostNameNode(appName dhcphostname, objName Entry, attrName option12, attrValue Huawei-HG553-instalacion
wlctl: Unsupported
xmlGetDhcpHostNameNode(appName dhcphostname, objName Entry, attrName option12, attrValue Huawei-HG553-instalacion
BcmAdsl_Initialize=0xC006A488, g_pFnNotifyCallback=0xC0083444
AnnexCParam=0x7FFF7EB8 AnnexAParam=0x00000980 adsl2=0x00000000
pSdramPHY=0xA3FFFFF8, 0x0 0x0
AdslCoreHwReset: AdslOemDataAddr = 0xA3FFBB64
AnnexCParam=0x7FFF7EB8 AnnexAParam=0x00000980 adsl2=0x00000000
dgasp: kerSysRegisterDyingGaspHandler: dsl0 registered
atmapi: prioritize receive packets
ip_tables: (C) 2000-2002 Netfilter core team
ip_conntrack version 2.1 (508 buckets, 0 max) - 368 bytes per conntrack
ip_conntrack_pptp version 2.1 loaded
ip_nat_pptp version 2.0 loaded
ip_nat_irc: Unknown symbol needs_ip_conntrack_irc
insmod: cannot insert `/lib/modules/2.6.8.1/kernel/net/ipv4/netfilter/ip_nat_irc.ko': Success (2): Success

==>   Bcm963xx Software Version: EchoLife_HG553V100R001C03B021.sip.allA2pB023k.d20h   <==

device eth0 entered promiscuous mode
br0: port 1(eth0) entering learning state
br0: topology change detected, propagating
br0: port 1(eth0) entering forwarding state
getopt returned char k
setIndexName3
pvc2684d: Interface "nas_0_44" created sucessfully

setIndexName3
pvc2684d: Communicating over ATM 0.0.44, encapsulation: LLC

device eth0 left promiscuous mode
br0: port 1(eth0) entering disabled state
eth0.2: MAC Address: 00:24:D2:1A:5F:81
eth0.3: MAC Address: 00:24:D2:1A:5F:81
eth0.4: MAC Address: 00:24:D2:1A:5F:81
eth0.5: MAC Address: 00:24:D2:1A:5F:81
device eth0.2 entered promiscuous mode
br0: port 1(eth0.2) entering learning state
br0: topology change detected, propagating
br0: port 1(eth0.2) entering forwarding state
device eth0.3 entered promiscuous mode
br0: port 2(eth0.3) entering learning state
br0: topology change detected, propagating
br0: port 2(eth0.3) entering forwarding state
device eth0.4 entered promiscuous mode
br0: port 3(eth0.4) entering learning state
br0: topology change detected, propagating
br0: port 3(eth0.4) entering forwarding state
device eth0.5 entered promiscuous mode
br0: port 4(eth0.5) entering learning state
br0: topology change detected, propagating
br0: port 4(eth0.5) entering forwarding state
acWlanTemp_ssid [ÿÿÿÿÿÿÿÿÿÿÿÿÿÿÿÿÿÿÿÿÿÿÿÿÿÿÿÿÿÿÿÿÿÿÿÿÿÿÿÿÿÿÿÿÿÿÿÿÿÿÿÿÿÿÿÿÿÿÿÿÿÿÿÿ]
device wl0 entered promiscuous mode
device wl0.1 entered promiscuous mode
device wl0.2 entered promiscuous mode
device wl0.3 entered promiscuous mode
br0: port 5(wl0) entering learning state
br0: topology change detected, propagating
br0: port 5(wl0) entering forwarding state
startWsc@3556 cfg_state=[1] wsc_mode=enabled
WlMngr::startWsc: client-pbc mode
*********************************************
Wi-Fi Simple Config Application - Intel Corp.
Version: Build 1.0.5, November 19 2006
*********************************************
Created @ Apr  2 2008 18:07:39
Initializing stack...button monitor start...!
 OK
Now starting stack
get mac = 00 24 D2 1A 5F 82
wl0: ignore i/f due to error(s)
sendto: Network is unreachable
register special.
sendto: Network is unreachable
original call init_spanish_mib
Setting default SIP configuration parameters.
NO UPnP @Configed Mode
wsc_del_ie: no valid ie was saved, len = -1

******* MODE: AP with built-in Registrar and UPnP Proxy *******
WSC: Build-in Registrar, wait for start command....
wsc_del_ie: no valid ie was saved, len = -1
Default SIP configuration parameters saved successfully.

 Voice application is started over LAN (br0)
=============start=========SIP: can't Retrieve psi object 10 in app Voice, errno 3
SIP: can't Retrieve psi object 11 in app Voice when DialPlan table size loading, errno 3
SIP: can't Retrieve psi object 13 in app Voice when CallForward table size loading, errno 3
iptables: Bad rule (does a matching rule exist in that chain?)
iptables: Bad rule (does a matching rule exist in that chain?)
iptables: Bad rule (does a matching rule exist in that chain?)
iptables: Bad rule (does a matching rule exist in that chain?)

SipMsgThread MsgThread pid=642
BOS: Enter bosInit
bosTimerInit
Enter bosAppInit
Exit bosAppInit
BOS: Exit bosInit
kernel::endpoint_open
kernel::endpoint_open COMPLETED
Created queue HDSP
00:01:00 CALLCLIENT: Initializing endpoints callSipClientMain
voipqosapi: sendto returned -1
sipConfig: sipzParamp=0x7fff7460 sipzParamp->regname= line 59 file  hsip.c
sipConfig: sipzParamp=0x7fff7460line 69 file  hsip.c
sipConfig: &mgscb=0x1000d1f0line 82 file  hsip.c
00:01:00 CALLCLIENT: Initializing endpoints
00:01:00 Endpoint will be initialized for country ESP (country code = 14)

00:01:00 Endpoint Event task started with pid 663...

00:01:00 Endpoint Packet task started with pid 664 ...

Enter bosStartApp


bosAppRootTask() - Is it morning already? Spawning app task (epoch #0)...



bosAppRootTask() - Is it morning already? Spawning app task (epoch #0)...

Enter TaskCreate aoAP
TaskCreate - spawn new task aoAP
Exit TaskCreate
AppResetDetectionEnable() - Enabled reset detection.
Exit bosStartApp
PLL init completed. PLL registers set to:
PCM->pcm_pll_ctrl1       = 0x00020001
PCM->pcm_pll_ctrl2       = 0x0008492B
PCM->pcm_pll_ctrl3       = 0x00001E1C
Set up PCM registers
Channel 0 assigned to timeslot 0
Channel 1 assigned to timeslot 1
Channel 2 assigned to timeslot 2
Tx Desc (0xA2D8E000): chan 0, buf 0, sts 0xe000, len 1280, bufp 0x2d8b000
Tx Desc (0xA2D8E008): chan 0, buf 1, sts 0x7000, len 1280, bufp 0x2d8b510
Rx Desc (0xA2D42000): chan 0, buf 0, sts 0x8000, len 1280, bufp 0x2d97000
Rx Desc (0xA2D42008): chan 0, buf 1, sts 0x9000, len 1280, bufp 0x2d97510
initIudma: chan 0, descBase 0xa2d42000, descBaseIudma 0x2d42000
initIudma: chan 1, descBase 0xa2d8e000, descBaseIudma 0x2d8e000
PCM ENABLE INFO: DMA0 IRQ STATUS 0x00000000
PCM ENABLE INFO: DMA0 IRQ MASK   0x00000005
PCM ENABLE INFO: DMA1 IRQ STATUS 0x00000000
PCM ENABLE INFO: DMA1 IRQ MASK   0x00000005
PCM ENABLE INFO: PCM  IRQ MASK    0x00000003
PCM ENABLE INFO: PCM  IRQ PENDING 0x00000007
Enter TaskCreate CMT_EXCEPTION_IST
TaskCreate - spawn new task CMT_EXCEPTION_IST
Exit TaskCreate
regStatus (reg 12 sel 0)    = 0x10008501
regStatus (reg 12 sel 7)    = 0x00000101
regCause  (reg 13 sel 0)    = 0x00000000
regCause  (reg 13 sel 7)    = 0x00808000
regCMT    (reg 22 sel 0)    = 0xe30e1006
regCMT    (reg 22 sel 1)    = 0xe8008003
Kicking off secondary thread processor at entry point 0x81099D00...
Secondary thread processor entry point at 0x81099d00
Thread processor handshake. Secondary app initialized properly.
Enter TaskCreate HTSK
TaskCreate - spawn new task HTSK
Exit TaskCreate
SUCCESS: Took semaphore
SUCCESS: Gave semaphore
INFO: MSPI POLLING MODE
INFO: IRQ MASK 0xa0020424
INFO: IRQ STATUS 0x400000
INFO: BLOCK ENABLES 0x3e0320
MSPI INITIALIZED
Enter boardHalSlicLe88221Init....
Read data from Rev ID register: 0x02, 0xB2
boardHalInit6358: Initialization complete.
boardHalInit completed
Enter TaskCreate HRTBEAT
TaskCreate - spawn new task HRTBEAT
Exit TaskCreate
HEARTBEAT: Initialized!
bosMsgQCreate: Created message queue VRGEVQ at address 0x5800b
Enter TaskCreate VRGEVPR
TaskCreate - spawn new task VRGEVPR
Exit TaskCreate
Enter TaskCreate HCAS
TaskCreate - spawn new task HCAS
Exit TaskCreate
*** gStartRxDesc[0] = 0xA2D42000
*** gBufferSizeBytes = 1280
*** gStartTxDesc[0] = 0xA2D8E000
hal6358PcmInit 260 nextTxDesc = 0xA2D8E000
hal6358PcmInit 260 nextTxDesc = 0xA2D8E008
hal6358PcmInit 264 Ownership for TX desc not set. Use this buffer.
PERF->IrqMask   = 0xA0020424
PERF->IrqMask1  = 0x00800000
Default value for provItemId '222' did not exist

ENDPT: hdspVhdOpen Secondary Connection VHD success. DSP 0, VHD (0x50) of type: 0x0

ENDPT: Setting T.38 error correction mode for vhd 80 to 0x104

ENDPT: hdspVhdOpen Secondary Connection VHD success. DSP 0, VHD (0x51) of type: 0x0

ENDPT: Setting T.38 error correction mode for vhd 81 to 0x104

ENDPT: hdspVhdOpen Secondary Connection VHD success. DSP 0, VHD (0x52) of type: 0x0

ENDPT: Setting T.38 error correction mode for vhd 82 to 0x104

ENDPT: hdspVhdOpen Secondary Connection VHD success. DSP 0, VHD (0x53) of type: 0x0

ENDPT: Setting T.38 error correction mode for vhd 83 to 0x104
dgasp: kerSysRegisterDyingGaspHandler: endpoint registered
00:01:01
Enter vrgEndptCasTimeParamControl... minHookFlash = 80, maxHookFlash = 250.

ENDPT: EPTYPE_FXS

ENDPT: hdspVhdOpen Line VHD success. DSP 0, VHD (0x54) of type: 0x7
Default value for provItemId '72' did not exist

InitVhds: tx = 0.
Default value for provItemId '73' did not exist

InitVhds: rx = 0.

minHookFlash = 80.

maxHookFlash = 250.
Default value for provItemId '213' did not exist
Default value for provItemId '41' did not exist
Default value for provItemId '66' did not exist
Default value for provItemId '58' did not exist
Default value for provItemId '215' did not exist
ENDPT: Initialization completed successfully for endpt 0

00:01:02 SIGNAL: endpt 0, cnx -1, evt 111 (TxGain), value 0
00:01:02 SIGNAL: endpt 0, cnx -1, evt 112 (RxGain), value 0
00:01:02 SIGNAL: endpt 0, cnx -1, evt 115 (FAXDETECT), value 3
ENDPT: EPTYPE_FXS

ENDPT: hdspVhdOpen Line VHD success. DSP 0, VHD (0x55) of type: 0x7
Default value for provItemId '72' did not exist

InitVhds: tx = 0.
Default value for provItemId '73' did not exist

InitVhds: rx = 0.

minHookFlash = 80.

maxHookFlash = 250.
Default value for provItemId '213' did not exist
Default value for provItemId '41' did not exist
Default value for provItemId '66' did not exist
Default value for provItemId '58' did not exist
Default value for provItemId '215' did not exist
ENDPT: Initialization completed successfully for endpt 1

00:01:02 SIGNAL: endpt 1, cnx -1, evt 111 (TxGain), value 0
00:01:02 SIGNAL: endpt 1, cnx -1, evt 112 (RxGain), value 0
00:01:02 SIGNAL: endpt 1, cnx -1, evt 115 (FAXDETECT), value 3
00:01:02  RTP read thread started with pid 672

00:01:02  RTP read thread started with pid 673

00:01:02  RTP read thread started with pid 674

00:01:02  RTP read thread started with pid 675

00:01:02  RTCP thread started with pid 676

00:01:02 rtpInit: RTCP task created, taskId = 12301
00:01:02 CALLCLIENT: Initialization complete callSipClientMain
00:01:02 ccPublishSipEventCB: event 0

00:01:02
 ====== HSPA voice Read Thread start ======

======start No voice process 4 times=====
Scratch pad is not initialized.
No scratch pad found.  Initialize scratch pad...
URL Filer: open rule file failed!
In webmain, setup wlan
ioctl: no such command
ioctl: Inappropriate ioctl for device

<TR064>Line:148=====start up mac=00:24:d2:1a:5f:81

<TR064>Line:151=====syspwd=VF-EShg553
SSDP server socket OK!

<TR064>File=main.c,Line=228,upnp set up ? 0

<TR064>File=main.c,Line=454,wanname=nas_0_44

<TR064>File=main.c,Line=454,wanname=ppp_255_65535_1

<TR064>File=main.c,Line=456,wannum=2

<TR064>File=main.c,Line=464,FindMyPvc=ffffffff
br0: port 5(wl0) entering disabled state
br0: port 5(wl0) entering learning state
br0: topology change detected, propagating
br0: port 5(wl0) entering forwarding state
startWsc@3556 cfg_state=[1] wsc_mode=enabled
WlMngr::startWsc: client-pbc mode
*********************************************
Wi-Fi Simple Config Application - Intel Corp.
Version: Build 1.0.5, November 19 2006
*********************************************
Created @ Apr  2 2008 18:07:39
Initializing stack...button monitor start...!
 OK
Now starting stack
get mac = 00 24 D2 1A 5F 82
wl0: ignore i/f due to error(s)
Init  port is  80
br0: port 2(eth0.3) entering disabled state
br0: port 3(eth0.4) entering disabled state
br0: port 4(eth0.5) entering disabled state

 [BcmSipHspaQuery_Spain, 5851] enter Spain Voice channel Query
iptables: Bad rule (does a matching rule exist in that chain?)
iptables: Bad rule (does a matching rule exist in that chain?)

 HspaServiceStart, 3755, HSPA_DBG: hspa  service start
sendto: Network is unreachable
sendto: Network is unreachable

telnet function started!
start hspa service failed       !!!

 [BcmSipHspaQuery_Spain, 5851] enter Spain Voice channel Query
NO UPnP @Configed Mode

******* MODE: AP with built-in Registrar and UPnP Proxy *******
WSC: Build-in Registrar, wait for start command....
ttyUSB.c,1460,WritePcui(),msgrcv is interrupted, try again
sendto: Network is unreachable
sendto: Network is unreachable
cDataMode   is  1

 [BcmSipHspaQuery_Spain, 5851] enter Spain Voice channel Query
sendto: Network is unreachable
sendto: Network is unreachable
CFM Socket API: receiving error
accept: Resource temporarily unavailable
sendto: Network is unreachable
sendto: Network is unreachable
sendto: Network is unreachable
sendto: Network is unreachable

comment:20 Changed 5 years ago by rway07@…

For a wrong GPIO mapping, we can check if the original source code can be helpful. There is also the source code from Huawei site.

comment:21 Changed 5 years ago by falco

For building original source firmware released by huawei: www [dot] nabuk.org/f/index.php?topic=3481.msg28369

comment:22 Changed 5 years ago by protomax

After some research, i'm able to reset the device on boot time without powering off the router (using a button switch on the dc connector), after reboot, ehci modules still work.

Using this, i booted the device several times (from power off state) resetted at some point and then flashed from cfe. Using binary search i can say that "the magic" that is doing the stock firmware is inside these lines (taken using serial console).

NET: Registered protocol family 8
NET: Registered protocol family 20
802.1Q VLAN Support v1.8 Ben Greear <greearb@candelatech.com>
All bugs added by David S. Miller <davem@redhat.com>
VFS: Mounted root (squashfs filesystem) readonly.
Freeing unused kernel memory: 76k freed
init started:  BusyBox v1.00 (2009.04.09-03:43+0000) multi-call binary
Algorithmics/MIPS FPU Emulator v1.5


BusyBox v1.00 (2009.04.09-03:43+0000) Built-in shell (msh)
Enter 'help' for a list of built-in commands.


Loading drivers and kernel modules...

atmapi: module license 'Proprietary' taints kernel.
blaadd: blaa_detect entry
adsl: adsl_init entry
Broadcom BCMPROCFS v1.0 initialized
Broadcom BCM6358A1 Ethernet Network Device v0.3 Apr  8 2009 11:18:06
Config Ethernet Switch Through MDIO Pseudo PHY Interface
dgasp: kerSysRegisterDyingGaspHandler: eth0 registered
eth0: MAC Address: 00:24:D2:1A:5F:81
DSP Driver: DSP init stub
eth0 Link UP.
PCI: Setting latency timer of device 0000:00:01.0 to 64
PCI: Enabling device 0000:00:01.0 (0004 -> 0006)
wl: srom not detected, using main memory mapped srom info (wombo board)
wl0: wlc_attach: use mac addr from the system pool by id: 0x776c0000
wl0: MAC Address: 00:24:D2:1A:5F:82
wl0: Broadcom BCM4318 802.11 Wireless Controller 4.150.10.15.cpe2.2b
dgasp: kerSysRegisterDyingGaspHandler: wl0 registered
Endpoint: endpoint_init entry
BOS: Enter bosInit
Enter bosAppInit
Exit bosAppInit
BOS: Exit bosInit
Endpoint: endpoint_init COMPLETED
drivers/usb/serial/usb-serial.c: USB Serial support registered for option1
usbcore: registered new driver option
drivers/usb/serial/option.c: USB Driver for GSM modems: v0.7.1
144
wlctl: Unsupported
ip is  192.168.0.1mask is  255.255.255.0, ipbegin is  192.168.0.192, ipend is  192.168.0.254
xmlGetDhcpHostNameNode(appName dhcphostname, objName Entry, attrName option12, attrValue Huawei-HG553-instalacion
wlctl: Unsupported
xmlGetDhcpHostNameNode(appName dhcphostname, objName Entry, attrName option12, attrValue Huawei-HG553-instalacion
BcmAdsl_Initialize=0xC006A488, g_pFnNotifyCallback=0xC0083444
AnnexCParam=0x7FFF7EB8 AnnexAParam=0x00000980 adsl2=0x00000000
pSdramPHY=0xA3FFFFF8, 0x1F5BD 0xDEADBEEF
AdslCoreHwReset: AdslOemDataAddr = 0xA3FFBB64
AnnexCParam=0x7FFF7EB8 AnnexAParam=0x00000980 adsl2=0x00000000
dgasp: kerSysRegisterDyingGaspHandler: dsl0 registered
atmapi: prioritize receive packets
ip_tables: (C) 2000-2002 Netfilter core team
ip_conntrack version 2.1 (508 buckets, 0 max) - 368 bytes per conntrack
ip_conntrack_pptp version 2.1 loaded
ip_nat_pptp version 2.0 loaded
ip_nat_irc: Unknown symbol needs_ip_conntrack_irc
insmod: cannot insert `/lib/modules/2.6.8.1/kernel/net/ipv4/netfilter/ip_nat_irc.ko': Success (2): Success

maybe from this, we could use a custom build of stock firmware to confirm my assumptions.

comment:23 in reply to: ↑ 17 Changed 5 years ago by anonymous

Replying to anonymous:

The differences between working (Thai) and not working (openwrt) is only one GPIO:

gpio-23 (adsl:blue ) out lo (Thai)

gpio-23 (adsl:blue ) out hi (openwrt)

But it could be useless...

Yes as the Thai (working router) gpio matches with protomax unworking router

comment:24 Changed 5 years ago by falco

I've uploaded some files from hg553 huawei source: www [dot] filefactory [dot ] com/file/3j5lwkwwookt/n/hg553_files.zip

there are some address of register etc...

comment:25 Changed 5 years ago by rway07@…

Part of boot messages displayed by protomax I think are generated from this file.

# /etc/profile: system-wide .profile file for the Bourne shells

PATH=/bin:/sbin:/usr/bin
KERNELVER=2.6.8.1
export PATH
echo
firsttime=`echo /var/udhcpd/udhcpd.lease*`
if [ "$firsttime" = "/var/udhcpd/udhcpd.lease*" ]; then
 echo "Loading drivers and kernel modules... "
 echo
# no-op
# create directory in /var mounted for TMPFS
 mkdir -p /var/log /var/run /var/state/dhcp /var/ppp /var/udhcpd /var/zebra /var/siproxd
 echo > /var/udhcpd/udhcpd.leases
 ifconfig lo 127.0.0.1 netmask 255.0.0.0 broadcast 127.255.255.255 up
# /etc/modules_install /lib/modules/$KERNELVER/extra
 test -e /lib/modules/$KERNELVER/extra/profdrvdd.ko && insmod /lib/modules/$KERNELVER/extra/profdrvdd.ko
 test -e /lib/modules/$KERNELVER/extra/atmapi.ko && insmod /lib/modules/$KERNELVER/extra/atmapi.ko
 test -e /lib/modules/$KERNELVER/extra/blaa_dd.ko && insmod /lib/modules/$KERNELVER/extra/blaa_dd.ko
 test -e /lib/modules/$KERNELVER/extra/adsldd.ko && insmod /lib/modules/$KERNELVER/extra/adsldd.ko
 test -e /lib/modules/$KERNELVER/extra/bcmprocfs.ko && insmod /lib/modules/$KERNELVER/extra/bcmprocfs.ko
 test -e /lib/modules/$KERNELVER/extra/bcm_enet.ko && insmod /lib/modules/$KERNELVER/extra/bcm_enet.ko
 test -e /lib/modules/$KERNELVER/extra/bcm_usb.ko && insmod /lib/modules/$KERNELVER/extra/bcm_usb.ko
 test -e /lib/modules/$KERNELVER/extra/wl.ko && rm -f /var/wlver  
 test -e /lib/modules/$KERNELVER/extra/wl.ko && insmod /lib/modules/$KERNELVER/extra/wl.ko && wlctl ver > /var/wlver  
 test -e /lib/modules/$KERNELVER/extra/wl.ko && test ! -e /var/wlver && reboot
 test -e /lib/modules/$KERNELVER/extra/endpointdd.ko && insmod /lib/modules/$KERNELVER/extra/endpointdd.ko
 test -e /lib/modules/kernel/drivers/usb/media/gspca.ko && insmod /lib/modules/kernel/drivers/usb/media/gspca.ko
# cfm
 echo "Done"
fi

comment:26 Changed 5 years ago by protomax

After some tests, i can confirm that when you boot with stock firmware and then flash with openwrt, wifi:blue (not mapped led) is always on.

After powering down the router, led is off but no changes happen on gpio state list.

comment:27 Changed 5 years ago by anonymous

Someone can explain why the led wifi:blue is not mapped? And where we can add this address (if anyone find it...)

comment:28 Changed 5 years ago by protomax

After some tests, i noticed that usb stops working with no reason, from one boot to another, and when it's broken, if you power down the device and swap/remove or add an ethernet cable, sometimes it starts working again.

This is happening using only openwrt.

maybe current or device frequency problem?

comment:29 Changed 5 years ago by protomax

if i recall correctly, on some revisions it's mapped, and when it's not, wifi:blue is working as it should (wifi activity)

comment:30 follow-up: Changed 5 years ago by rway07

As reported in this ticket by danitool:
https://dev.openwrt.org/ticket/11375

removing this line:

ohci->num_ports = 1;

from drivers/usb/host/ohci-bcm63xx.c, both usb ports work with ohci module. After that, writing particular values ​​in memory locations 0xfffe1500 and 0xfffe150c and unloading usb modules,you get a system freeze. After reboot, both usb ports are working as ehci.

According to the source code of huawei and openwrt, in the 0xfffe1500 location there is the SwapControl Register and location 0xfffe150c is unused.

I'm trying to understand how a unused memory location (corresponding to an internal address of the USB ports?) and the swap register affects the module ehci.

comment:31 Changed 5 years ago by falco

Hi, some weeks ago me and rway have tried to solve this problem, we have no deep knowledge of the Linux kernel and the usb drivers for openwrt, we only discovered that by writing some values ​​in certain memory locations the router goes into kernel panic, at reboot the router work properly and usb work as ehci.
Florian, you know much better the system, you can not give us any advice?

https://forum.openwrt.org/viewtopic.php?pid=167106#p167106

comment:32 in reply to: ↑ 2 Changed 5 years ago by anonymous

Replying to sanzojn@…:

I have the same problem, kmod-usb-ohci work, kmod-usb2 doesn't work. Same board, HG553

a solution to make both ports in full functionality is to add ignore-oc after ehci-hcd in the file /etc/modules.d/40-usb2 so the correct line is "ehci-hcd ignore-oc"
both port became active even if the port near lan plug is only usb2 and not recognize the usb1 devices, i plug a 4 port usb2 hub to it and solve even the retrocompatibility.
BR
Cillo273

comment:33 follow-up: Changed 5 years ago by sanzojn@…

@Cillo273

With this mod the top usb port is 2.0 or 1.1 capable?

comment:34 in reply to: ↑ 33 ; follow-ups: Changed 5 years ago by anonymous

Replying to sanzojn@…:

@Cillo273

With this mod the top usb port is 2.0 or 1.1 capable?

the upper port remain only usb1 capable in my router.
cillo273

comment:35 in reply to: ↑ 34 Changed 5 years ago by anonymous

Replying to anonymous:

Replying to sanzojn@…:

@Cillo273

With this mod the top usb port is 2.0 or 1.1 capable?

the upper port remain only usb1 capable in my router.
cillo273

ok, with the standard firmware are both usb 2.0, but at least with your edit work both

comment:36 in reply to: ↑ 34 Changed 5 years ago by anonymous

Replying to anonymous:

Replying to sanzojn@…:

@Cillo273

With this mod the top usb port is 2.0 or 1.1 capable?

can you tell us what revision are you using? And what version of kernel?
in this days i can try with my hg553 and i would like to have same version of you.
Thanks

comment:37 Changed 5 years ago by rway07@…

I tried this workaround on a openwrt trunk with kernel 3.0.18, but it does not work on my HG553.

comment:38 Changed 4 years ago by protomax

I tested 2 routers with a clean ATTITUDE ADJUSTMENT (12.09, r36088) and both ports are working fine, always.

comment:39 Changed 4 years ago by rway07@…

Thanks for the information! I will test that openwrt revision on my hg553 and let's see the outcome!

comment:40 Changed 4 years ago by rway07@…

I've tried. The last revision (38621) with kernel 3.3.8 works with ehci. So seems that it finally works as usb2.

comment:41 Changed 4 years ago by florian

  • Resolution set to worksforme
  • Status changed from accepted to closed

comment:42 Changed 4 years ago by anonymous

Vodafone Station Italy, S/n 312988k14012.

As of r39402 Usb ports behaviour is still unpredictable.
Sometimes the top port is 2.0 and the low port is 1.1 only, other times it's the contrary, other times again they are both 1.1 only.

If both ports are 1.1 only, a possible workaround is: unplug peripheral, 'poweroff', switch off, switch on, wait for reboot, retry plugging.
:/

comment:43 in reply to: ↑ 30 ; follow-up: Changed 3 years ago by danitool <dgcbueu@…>

Replying to rway07:

As reported in this ticket by danitool:
https://dev.openwrt.org/ticket/11375

removing this line:

ohci->num_ports = 1;

from drivers/usb/host/ohci-bcm63xx.c, both usb ports work with ohci module. After that, writing particular values ​​in memory locations 0xfffe1500 and 0xfffe150c and unloading usb modules,you get a system freeze. After reboot, both usb ports are working as ehci.

According to the source code of huawei and openwrt, in the 0xfffe1500 location there is the SwapControl Register and location 0xfffe150c is unused.

I'm trying to understand how a unused memory location (corresponding to an internal address of the USB ports?) and the swap register affects the module ehci.

Based on this comment I guess found a fix. Looking at the Huawei released gpl it seems this code:

    unsigned int * reg = (unsigned int *) 0xfffe150c;
    /* power cycle the USB PLL */
	*reg &= ~0x02000000;
	mdelay(1);
	*reg |= 0x02000000;

might help to get rid of this problem. I found the code into the function prom_init at the prom.c file.

I cannot test it since I never noticed this problem in my router, neither I use the USB port with high speed devices very much.

I just leave this commen FYI.

comment:44 Changed 3 years ago by jow

  • Milestone changed from Attitude Adjustment 12.09 to Barrier Breaker 14.07

Milestone Attitude Adjustment 12.09 deleted

comment:45 Changed 3 years ago by berman72@…

so, give me the working .bin link, i have tried 12.09 (r36088) from wiki download area, but still not working. And please, give step by step package installation or configuration change ...

comment:46 in reply to: ↑ 43 Changed 3 years ago by anonymous

  • Resolution worksforme deleted
  • Status changed from closed to reopened

Replying to danitool <dgcbueu@…>:

Replying to rway07:

As reported in this ticket by danitool:
https://dev.openwrt.org/ticket/11375

removing this line:

ohci->num_ports = 1;

from drivers/usb/host/ohci-bcm63xx.c, both usb ports work with ohci module. After that, writing particular values ​​in memory locations 0xfffe1500 and 0xfffe150c and unloading usb modules,you get a system freeze. After reboot, both usb ports are working as ehci.

According to the source code of huawei and openwrt, in the 0xfffe1500 location there is the SwapControl Register and location 0xfffe150c is unused.

I'm trying to understand how a unused memory location (corresponding to an internal address of the USB ports?) and the swap register affects the module ehci.

Based on this comment I guess found a fix. Looking at the Huawei released gpl it seems this code:

    unsigned int * reg = (unsigned int *) 0xfffe150c;
    /* power cycle the USB PLL */
	*reg &= ~0x02000000;
	mdelay(1);
	*reg |= 0x02000000;

might help to get rid of this problem. I found the code into the function prom_init at the prom.c file.

I cannot test it since I never noticed this problem in my router, neither I use the USB port with high speed devices very much.

I just leave this commen FYI.

i can confirm that all worked when i added that code to prom_init !!!!!!!!!!!!!!!!!!!! I am so happy :)))... someone needs to create patch :)))

comment:47 Changed 3 years ago by marcogaio

I've finally test that patch, and i can confirm it works.

Looking at the code (i'm not a kernel hacker, so...) i've found better to patch not prom.c but instead the file board_bcm963xx.c.

Attached my patch, that you can put on target/linux/brcm63xx/patches-3.3/ folder and rebuild the firmware.

Changed 3 years ago by marcogaio

comment:48 Changed 3 years ago by marcogaio

Ahem, forgot to say... patch obviously tested against AA kernel, i've not right now a BB build environment. If someone have one, tests welcomed!

Note also that the registers quirks are applied only when inline function BCMCPU_IS_6358() is true; probably it is better if quirks is applied ONLY if THE BOARD is a HW553, but i've not found a way to use or build an inline function BCMBOARD_IS_HW553() .

So, probably this patch cannot be applied generally. because can be a potential source of trouble for other broadcom board with 6358 CPU *AND* not HW553. ;(

comment:49 Changed 3 years ago by danitool

Hi marcogaio, I think to use the patch for all bcm6358 boards is OK, other boards might benefit this patch also. And since making a USB pll reset seems to be harmless when loading the kernel I don't see any inconvenience.

You should now test Barrier Braker and trunk in your router without the patch, to check if problem persist with later versions. And then adapt the patch to build again Barrier Braker and trunk, and check again if the problem is gone. Finally you should send the patch to the mailing list.

Testing is important in latest versions, because they are the ones which accept patches by the Openwrt Developer team. I would send a patch but I didn't notice the USB problem, nor have a HG553 device to test this stuff.

comment:50 Changed 3 years ago by marcogaio

Today i've debricked (flashed via jtag an open CFE, the same CFE of other router) my third vodafone station, flashed the stock BB firmware (the same flashed some month ago, was dated 2/10/2014) and... WORK! USB2.0 works flawlessy...

So seems to be that probably the USB2.0 bug is present only on some board revision ,or is triggered also by other things... boh...

Sorry, but in my first and second router i need AA, and have to be put in production very soon, so... i've exausted my test system.

I hope to be able to do some tests with help of some friend...

comment:51 Changed 2 years ago by Yo_Julio

Hello
I'm making a MPD server in a friend's HG553 so I can do some tests for a while.

Trunk (04/24/2015): Tiny blue light, no network activity, no http, telnet nor dhcp
BB: Tiny blue light, no usb
AA: Strong red light, 1 usb EHCI + 1 usb OHCI (everything working OK)

If anybody can make a bakported AA or BB kernel with the prom.init modification I will test It

comment:52 Changed 2 years ago by marcogaio

Sorry for the late answer.

You can find here:

http://eraldo.lilliput.linux.it/~gaio/OpenWRT/HW553/

my firmwares with patch applied. The 'aa' is a heavily custom firmware i use in production, and contain asterisk and chan_dongle amongst other things.

The 'bb' firmware is a rather stock one, probably have only the usb drivers within, and misses luci AFAI'remember well.

Say me (and give me more time... ;-) to make some other custom firmwares...

comment:53 Changed 2 years ago by marcin1j

Hi guys

I've just tested marcogaio's patch on one of my routers. Works perfectly, making both ports USB 2.0 capable.
Note that if you want to compile bleeding edge (Chaos Calmer), the original file needs slight adaptation. I'll attach 900-board_hw553-usbfix-cc.patch in case someone needs it.

I hope some solution will soon find its way into the repository as the lack of high-speed USB is really a show-stopper for most users.
Undoubtedly, the tricky part is to decide where (in the patch, it's the first statement in board_bcm963xx_init, which seems a little awkward) and when (really all bc6358 devices?) this reset routine should be performed.
Indeed, in trunk the function board_early_setup seems to be a better place for such routine ie. something like this (except for the inline variable declaration) would be probably more consistent with existing code:

  • arch/mips/bcm63xx/boards/board_common.c

    a b  
    1515#include <linux/platform_device.h> 
    1616#include <linux/ssb/ssb.h> 
    1717#include <linux/gpio_keys.h> 
     18#include <linux/delay.h> 
    1819#include <linux/spi/spi.h> 
    1920#include <asm/addrspace.h> 
    2021#include <asm/bootinfo.h> 
    void __init board_early_setup(const stru 
    132133               val |= GPIO_PINMUX_SEL0_GPIO13_PWRON; 
    133134               bcm_gpio_writel(val, GPIO_PINMUX_SEL0_6318); 
    134135       } 
     136 
     137       /* power cycle the USB PLL */ 
     138       if (BCMCPU_IS_6358()) { 
     139               unsigned int * reg = (unsigned int *) 0xfffe150c; 
     140               printk(KERN_INFO PFX "Resetting USB PLL..."); 
     141               *reg &= ~0x02000000; 
     142               mdelay(1); 
     143               *reg |= 0x02000000; 
     144               printk(" done.\n"); 
     145       } 
    135146#endif 
    136147} 
    137148 

Moreover, at first glance this memory location seems to be a register. Isn't this really toggling a GPIO pin, as florian's suggested? The code for bcm6318, partially seen in the context lines bears some resemblance, however GPIO_PINMUX_SEL0_GPIO13_MASK != GPIO_PINMUX_SEL0_GPIO13_PWRON toggles 2 bits whereas we toggle only one.
I'm not familiar with low-level architecture in general and Broadcom in particular, so this is only my guess ;)

Changed 2 years ago by marcin1j

900-board_hw553-usbfix.patch adapted for trunk

Changed 2 years ago by marcin1j

900-board_hw553-usbfix.patch adapted for trunk

comment:54 follow-up: Changed 2 years ago by Yo_Julio

Hi marcogaio
Neither of the squashfs (BB nor AA) works on my router (I downloaded and tested them twice)

You can see putty log below: (similar in both firmwares)

..
...
[ 0.576000] NET: Registered protocol family 17
[ 0.580000] Bridge firewalling registered
[ 0.584000] 8021q: 802.1Q VLAN Support v1.8
[ 0.592000] SQUASHFS error: Filesystem uses "zlib" compression. This is not supported
[ 0.600000] jffs2_scan_eraseblock(): Magic bitmask 0x1985 not found at 0x00000000: 0x6873 instead
[ 0[ 0.576000] NET: Registered protocol family 17
[ 0.580000] Bridge firewalling registered
[ 0.584000] 8021q: 802.1Q VLAN Support v1.8
[ 0.592000] SQUASHFS error: Filesystem uses "zlib" compression. This is not supported
[ 0.600000] jffs2_scan_eraseblock(): Magic bitmask 0x1985 not found at 0x00000000: 0x6873 instead
[ 0.612000] jffs2_scan_eraseblock(): Magic bitmask 0x1985 not found at 0x00000004: 0x4f04 instead
[ 0.620000] jffs2_scan_eraseblock(): Magic bitmask 0x1985 not found at 0x00000008: 0xfacd instead
[ 0.628000] jffs2_scan_eraseblock(): Magic bitmask 0x1985 not found at 0x00000010: 0x1400 instead
[ 0.636000] jffs2_scan_eraseblock(): Magic bitmask 0x1985 not found at 0x00000014: 0x0100 instead
[ 0.648000] jffs2_scan_eraseblock(): Magic bitmask 0x1985 not found at 0x00000018: 0xc002 instead
[ 0.656000] jffs2_scan_eraseblock(): Magic bitmask 0x1985 not found at 0x0000001c: 0x0400 instead
[ 0.664000] jffs2_scan_eraseblock(): Magic bitmask 0x1985 not found at 0x00000020: 0x500e instead
[ 0.676000] jffs2_scan_eraseblock(): Magic bitmask 0x1985 not found at 0x00000028: 0x508c instead
[ 0.684000] jffs2_scan_eraseblock(): Magic bitmask 0x1985 not found at 0x00000030: 0x488c instead
[ 0.692000] Further such events for this erase block will not be printed
[ 0.700000] Empty flash at 0x00000038 ends at 0x00000040
[ 0.752000] Old JFFS2 bitmask found at 0x0001b3bc
[ 0.756000] You cannot use older JFFS2 filesystems with newer kernels
[ 0.768000] jffs2_scan_eraseblock(): Magic bitmask 0x1985 not found at 0x00020000: 0xa355 instead
...
...
...
...
...
...
[ 12.060000] jffs2_scan_eraseblock(): Magic bitmask 0x1985 not found at 0x00d20020: 0x8892 instead
[ 12.068000] jffs2_scan_eraseblock(): Magic bitmask 0x1985 not found at 0x00d20024: 0xe7af instead
[ 12.076000] Further such events for this erase block will not be printed
[ 12.100000] Old JFFS2 bitmask found at 0x00d28708
[ 12.104000] You cannot use older JFFS2 filesystems with newer kernels
[ 12.148000] jffs2_scan_eraseblock(): End of filesystem marker found at 0xd40000
[ 12.156000] jffs2_build_filesystem(): unlocking the mtd device... done.
[ 12.164000] jffs2_build_filesystem(): erasing all blocks after the end marker...
done.
[ 59.296000] JFFS2 notice: (1) jffs2_build_xattr_subsystem: complete building xattr subsystem, 0 of xdatum (0 unchecked, 0 orphan) and 0 of xref (0 dead, 0 orphan) found.
[ 59.312000] VFS: Mounted root (jffs2 filesystem) readonly on device 31:2.
[ 59.324000] Freeing unused kernel memory: 200k freed
[ 59.328000] Kernel panic - not syncing: No init found. Try passing init= option to kernel. See Linux Documentation/init.txt for guidance.

Regards
Julio.


comment:55 Changed 2 years ago by Yo_Julio

I downloaded the firmware from the hg556 TOH page (hg556a_backport_12.09.zip) and retagged It as HG553. It works flawlesly (two USB 2.0 ports) Board is: HG55MAGV VER D

Anyway I can borrow the router again and test any firmware

comment:56 in reply to: ↑ 54 Changed 2 years ago by marcogaio

Replying to Yo_Julio:

Hi marcogaio
Neither of the squashfs (BB nor AA) works on my router (I downloaded and tested them twice)

Sorry, i've completely forgot that. I've write about in openwrt list, but not here.

This trouble happens also to me, but also with the stock firmwares. Seems me a bug of the CFE webpage used to upload firmwares, that seems to work only for the first firmware, not the subsequent ones.

Normally i do the reflash copying the new firmware image on /tmp and then doing:

mtd -r write /tmp/openwrt-HW553-squashfs-cfe.bin linux

anyway, the md5sum of the images are:

3be17b751a74ce6344c1b0659a8a8054 ./aa/bin/brcm63xx/openwrt-HW553-squashfs-cfe.bin
4b1d51c4092626c55540cd3cffa7d167 ./bb/bin/brcm63xx/openwrt-HW553-squashfs-cfe.bin

comment:57 follow-up: Changed 2 years ago by Yo_Julio

Hi marcogaio

After installing your BB compilation (mtd write) I type opkg update, but opkg refused to install usb stuff (kernel version mismatch) so I used force-depends option
Lots of unknown symbols after modprobe

modprobe usb2 and usb-storage
...
...
[ 2215.124000] ehci_platform: Unknown symbol usb_create_hcd (err 0)
[ 2215.132000] ehci_platform: Unknown symbol usb_remove_hcd (err 0)
[ 2215.136000] ehci_platform: Unknown symbol usb_add_hcd (err 0)
[ 2286.000000] usbcore: registered new interface driver usbfs
[ 2286.008000] usbcore: registered new interface driver hub
[ 2286.012000] usbcore: registered new device driver usb
[ 2306.104000] ehci_hcd: USB 2.0 'Enhanced' Host Controller (EHCI) Driver
[ 2488.220000] sd_mod: Unknown symbol scsi_mode_sense (err 0)
[ 2488.224000] sd_mod: Unknown symbol scsi_device_get (err 0)
[ 2488.232000] sd_mod: Unknown symbol scsi_setup_blk_pc_cmnd (err 0)
...
...
...
[ 2488.368000] sd_mod: Unknown symbol scsi_prep_return (err 0)
[ 2488.376000] sd_mod: Unknown symbol scsi_set_medium_removal (err 0)
[ 2504.148000] SCSI subsystem initialized
[ 2504.164000] usbcore: registered new interface driver usb-storage

After inserting a pendrive no (sda) disk is created (dmesg).


comment:58 Changed 2 years ago by anonymous

In the AA compilation ehci is registered

[ 15.868000] NET: Registered protocol family 24
[ 15.904000] ehci_hcd: USB 2.0 'Enhanced' Host Controller (EHCI) Driver
[ 16.016000] bcm63xx_ehci bcm63xx_ehci.0: BCM63XX integrated EHCI controller
[ 16.020000] bcm63xx_ehci bcm63xx_ehci.0: new USB bus registered, assigned bus number 1
[ 16.056000] bcm63xx_ehci bcm63xx_ehci.0: irq 18, io mem 0xfffe1300
[ 16.072000] bcm63xx_ehci bcm63xx_ehci.0: USB 2.0 started, EHCI 1.00, overcurrent ignored
[ 16.080000] hub 1-0:1.0: USB hub found
[ 16.084000] hub 1-0:1.0: 2 ports detected
[ 16.132000] nf_conntrack version 0.5.0 (965 buckets, 3860 max)
[ 16.720000] ohci_hcd: USB 1.1 'Open' Host Controller (OHCI) Driver
[ 16.832000] bcm63xx_ohci bcm63xx_ohci.0: BCM63XX integrated OHCI controller
[ 16.836000] bcm63xx_ohci bcm63xx_ohci.0: new USB bus registered, assigned bus number 2
[ 16.844000] bcm63xx_ohci bcm63xx_ohci.0: irq 13, io mem 0xfffe1400
[ 16.912000] hub 2-0:1.0: USB hub found
[ 16.916000] hub 2-0:1.0: 1 port detected
[ 16.960000] usbcore: registered new interface driver usbserial
[ 16.964000] USB Serial support registered for generic
[ 16.972000] usbcore: registered new interface driver usbserial_generic
[ 16.976000] usbserial: USB Serial Driver core
[ 17.076000] USB Serial support registered for GSM modem (1-port)
[ 17.080000] usbcore: registered new interface driver option

After inserting a flash disk in both ports, both of them appear to work fine

dmesg
...
[ 140.476000] usb 1-2: new high-speed USB device number 2 using bcm63xx_ehci
[ 156.440000] usb 1-2: USB disconnect, device number 2
...
...
[ 162.420000] usb 1-1: new high-speed USB device number 3 using bcm63xx_ehci
[ 199.668000] usb 1-1: USB disconnect, device number 3
root@OpenWrt:/#

comment:59 Changed 2 years ago by Yo_Julio

If you can make another BB firm or tell me wich are the good repositories I will test It

comment:60 in reply to: ↑ 57 Changed 2 years ago by marcogaio

Replying to Yo_Julio:

After installing your BB compilation (mtd write) I type opkg update, but opkg refused to install usb stuff (kernel version mismatch) so I used force-depends option

This is really a thing i don't understand. opkg complain about missing dependencies, but warn that the current kernel is XYZ and they want kernel XYZ (exactly the same version). Boh.

Lots of unknown symbols after modprobe

Reboot the router. I think some deps trouble get usb module not loaded in the correct sequence when installing, but get fixed on reboot.

Anyway exactly yesterday i was experimenting with a friend, and i've noted that my firmware was built with a very minimal setup, without USB support. Sorry to all.

I've rebuilt the firmware with at least USB controller and LUCI within.

You can find at the same place, MD5 now is cd68c2107245d0b4288ac612cf05f405 .

Probably usb-storage is still missing, i do my test using a USB GSM dongle (Huawey) because i need that. ;-)

comment:61 Changed 2 years ago by Yo_Julio

Hi marcogaio
You where right.
After rebooting there are no unknown symbols.
Both ports seems to be usb2 capable.
I installed mass storage stuff, block-mount fdisk and ntfs-3g
All devices are recogniced and sda1 & sdb1 are created but I can not mount any type of disk

[ 2312.984000] usb 1-2: new high-speed USB device number 6 using ehci-platform
[ 2313.136000] usb-storage 1-2:1.0: USB Mass Storage device detected
[ 2313.144000] scsi3 : usb-storage 1-2:1.0
[ 2314.232000] scsi 3:0:0:0: Direct-Access Kingston DataTraveler 2.0 PMAP PQ: 0 ANSI: 4
[ 2315.732000] sd 3:0:0:0: [sda] 60978816 512-byte logical blocks: (31.2 GB/29.0 GiB)
[ 2315.740000] sd 3:0:0:0: [sda] Write Protect is off
[ 2315.744000] sd 3:0:0:0: [sda] Mode Sense: 23 00 00 00
[ 2315.748000] sd 3:0:0:0: [sda] No Caching mode page found
[ 2315.752000] sd 3:0:0:0: [sda] Assuming drive cache: write through
[ 2315.764000] sd 3:0:0:0: [sda] No Caching mode page found
[ 2315.772000] sd 3:0:0:0: [sda] Assuming drive cache: write through
[ 2315.800000] sda: sda1
[ 2315.820000] sd 3:0:0:0: [sda] No Caching mode page found
[ 2315.828000] sd 3:0:0:0: [sda] Assuming drive cache: write through
[ 2315.832000] sd 3:0:0:0: [sda] Attached SCSI removable disk
root@OpenWrt:/# mount -t vfat /dev/sda1 /mnt/discousb
mount: mounting /dev/sda1 on /mnt/discousb failed: No such device
root@OpenWrt:/#

root@OpenWrt:/# fdisk -l /dev/sda

Disk /dev/sda: 29.1 GiB, 31221153792 bytes, 60978816 sectors
Units: sectors of 1 * 512 = 512 bytes
Sector size (logical/physical): 512 bytes / 512 bytes
I/O size (minimum/optimal): 512 bytes / 512 bytes
Disklabel type: dos
Disk identifier: 0xc3072e18

Device Boot Start End Blocks Id System
/dev/sda1 * 8064 60978815 30485376 c W95 FAT32 (LBA)

root@OpenWrt:/#
root@OpenWrt:/# mount -t vfat /dev/sda1 /mnt/discousb
mount: mounting /dev/sda1 on /mnt/discousb failed: No such device
root@OpenWrt:/#

comment:62 Changed 2 years ago by Yo_Julio

dmesg just after boot:

[ 18.196000] Broadcom 43xx driver loaded [ Features: PNL ]
[ 18.212000] ieee80211 phy0: Selected rate control algorithm 'minstrel_ht'
[ 18.280000] ext4: Unknown symbol blockdev_direct_IO (err 0)
[ 18.332000] fat: Unknown symbol
blockdev_direct_IO (err 0)
[ 18.436000] ext4: Unknown symbol blockdev_direct_IO (err 0)
[ 18.480000] fat: Unknown symbol
blockdev_direct_IO (err 0)
[ 24.144000] IPv6: ADDRCONF(NETDEV_UP): eth0: link is not ready
[ 24.468000] eth0: link UP - 100/full - flow control off
[ 24.480000] IPv6: ADDRCONF(NETDEV_CHANGE): eth0: link becomes ready
[ 33.724000] device eth0.1 entered promiscuous mode
[ 33.728000] device eth0 entered promiscuous mode
[ 33.736000] br-lan: port 1(eth0.1) entered forwarding state
[ 33.740000] br-lan: port 1(eth0.1) entered forwarding state
[ 34.580000] eth0: link UP - 100/full - flow control off
[ 35.744000] br-lan: port 1(eth0.1) entered forwarding state
root@OpenWrt:/#

comment:63 Changed 2 years ago by Yo_Julio

Hi
This is a backported AA that works for me (with 2 EHCI USB)

https://docs.google.com/file/d/0B4xsvBckymqtZ29MVFhxR2VjODA/edit?pli=1

I uninstall swconfig, then install robocfg and I have now VLAN & 2 x 2.0 USB ports. That's what I was looking for.

marcogaio, regarding the issues in your BB compilation I think that they are related to mass storage module but EHCI USB works fine.

comment:64 follow-up: Changed 2 years ago by primes2h

Hi there, i've just tried marcin1j patch against trunk (Chaos Calmer r45459) and it works like a charm.

I think it can be added in trunk code.

BTW, I'm the guy who made experiments with marcogaio ;-)

comment:65 Changed 2 years ago by primes2h

Forgot to mention, here you have the patched trunk firmware:

https://drive.google.com/file/d/0B-9d-ljukfCkelpwZzk1RGFxb2c/view

It contains several kmod-usb packages (e.g. usb-storage support).

Have fun.

comment:66 in reply to: ↑ 64 Changed 2 years ago by anonymous

Replying to primes2h:

Hi there, i've just tried marcin1j patch against trunk (Chaos Calmer r45459) and it works like a charm.

I think it can be added in trunk code.

This patch works but is by no means ready for inclusion, which I clearly stated.

First of all, the whole code is probably a crude way of toggling mysterious GPIO line. If so, someone with Broadcom SoC platform knowledge should express this as a correct line number/pinmux and use predefined macros instead. The delay might be unnecessary, too.
Secondly, this "reset" routine is misplaced, see inline patch in comment:53 for a more appropriate location.

What I needed was to quickly prepare a new router for use with usb flash stick. In this respect, attached patch did the job.
Lacking low-level platform knowledge, I can only tell as much as that it's strongly inconsistent with the rest of the codebase. I'd rather encourage florian to rewrite this in a right way and provide him some feedback.

Add Comment

Modify Ticket

Action
as reopened .
Author


E-mail address and user name can be saved in the Preferences.

 
Note: See TracTickets for help on using tickets.